﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {        
        ProcessProxyRequest("http://localhost:7047/DynamicsNAV70/WS/CRONUS Danmark A%2FS/Codeunit/Phone_Demo", Request, Response);
    }
    void ProcessProxyRequest(string requesturl, HttpRequest request, HttpResponse response)
    {
        HttpWebRequest webRequest = HttpWebRequest.Create(requesturl + "?" + Request.QueryString) as HttpWebRequest; // Connect to NAV Webservice
        webRequest.KeepAlive = false;
        webRequest.Credentials = CredentialCache.DefaultCredentials; // Windows credentials - IIS Setup
        webRequest.Method = request.HttpMethod;
        webRequest.ContentType = request.ContentType;
        webRequest.ContentLength = request.ContentLength;
        foreach (string Key in Request.Headers) // Add headers we might be missing..
            try
            {
                webRequest.Headers.Add(Key, Request.Headers[Key]);
            }
            catch { }
        if (webRequest.Method == "POST") // Send POST Data to NAV
        {
            Stream PostData = webRequest.GetRequestStream();
            int l = (int)Request.InputStream.Length;
            request.InputStream.CopyTo(PostData, l);
            PostData.Close();
        }
        using (HttpWebResponse NAVResponse = (HttpWebResponse)webRequest.GetResponse()) // Get Response from NAV
        {
            Stream receiveStream = NAVResponse.GetResponseStream();
            response.Clear();
            response.ClearContent();
            response.ClearHeaders();
            foreach (string header in NAVResponse.Headers) // Transfer NAV response headers
                response.AppendHeader(header, NAVResponse.Headers[header]);
            receiveStream.CopyTo(response.OutputStream);  // Transfer NAV reponse data to client
            receiveStream.Close();
            NAVResponse.Close();
        }
    }
}

